﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Text;
using System.Drawing.Drawing2D;

namespace howto_smooth_path_text
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Use a big font.
        private void Form1_Load(object sender, EventArgs e)
        {
            this.AutoScaleMode = AutoScaleMode.None;
            this.Font = new Font("Times New Roman", 30, FontStyle.Bold, GraphicsUnit.Pixel);
        }

        // Draw text samples.
        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            int y = 10;
            e.Graphics.DrawString("DrawString Normal", this.Font, Brushes.Blue, 10, y);
            y += this.Font.Height;

            e.Graphics.TextRenderingHint = TextRenderingHint.AntiAliasGridFit;
            e.Graphics.DrawString("DrawString Smooth", this.Font, Brushes.Blue, 10, y);
            y += this.Font.Height;

            using (StringFormat string_format = new StringFormat())
            {
                string_format.Alignment = StringAlignment.Near;
                string_format.LineAlignment = StringAlignment.Near;

                using (GraphicsPath path = new GraphicsPath())
                {
                    path.AddString("DrawPath Normal", this.Font.FontFamily,
                        (int)this.Font.Style, this.Font.Size, new Point(10, y),
                        string_format);
                    e.Graphics.FillPath(Brushes.Blue, path);
                    y += this.Font.Height;
                }

                using (GraphicsPath path = new GraphicsPath())
                {
                    path.AddString("DrawPath Smooth", this.Font.FontFamily,
                        (int)this.Font.Style, this.Font.Size, new Point(10, y),
                        string_format);
                    e.Graphics.SmoothingMode = SmoothingMode.AntiAlias;
                    e.Graphics.FillPath(Brushes.Blue, path);
                    y += this.Font.Height;
                }
            }
        }
    }
}
